<?php

namespace App\Http\Controllers\Company;

use App\Http\Controllers\Controller;
use App\Models\AuctionCompany;
use App\Models\CompanyAuctionRate;
use App\Models\AuctionDetail;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
Use \Carbon\Carbon;


class AuctionCompanyController extends Controller
{  
     public function __construct( )
    {
        $this->middleware('auth');  
    } 
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    { 
    //    dd($request);
        try {
            DB::beginTransaction();  
            $e_auction_id =  decrypt($request->e_auction_id);
            $company_id = Auth::user()->id;
            $AuctionCompanyData['e_auction_id'] = $e_auction_id;
            $AuctionCompanyData['company_id'] = $company_id; 

           

            $AuctionCompany = AuctionCompany::create($AuctionCompanyData);
           
            $CompanyAuctionData =$request->CompanyAuction;
            $auction_company_id = $AuctionCompany->id;

            foreach ($CompanyAuctionData as  $value) { 
                $value['auction_company_id'] = $auction_company_id; //parent table id where company and auction data is saved
                $value['auction_detail_id'] = isset($value['auction_detail_id'])?decrypt($value['auction_detail_id']):"";
                $rate = isset($value['rate'])?$value['rate']:"";
                $value['rate']= encrypt($rate);
            
                CompanyAuctionRate::create($value);
            }

            DB::commit(); 
            return redirect('/')->with('success', 'You have succesfully fill this form.');
        } catch (\Throwable $th) { 
            DB::rollback(); 
            return redirect()->back()->with('error', $th->getMessage());
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    { 
        try {
            $id = decrypt($id);
             
            $auction_company = AuctionCompany::findOrFail($id);
            $e_auction = $auction_company->getAuctionDetail;
            $company_auction_rates = $auction_company->getAuctionRates;
            
            return view('company.e-auction.show', compact('company_auction_rates', 'auction_company', 'e_auction'));
            
        } catch (\Throwable $th) { 
            dd($th->getMessage());
            return redirect()->back()->with('error', $th->getMessage());
        }
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        
        try {
            $id = decrypt($id);

            
            
            $auction_company = AuctionCompany::findOrFail($id);
            // dd($auction_company);
            $e_auction = $auction_company->getAuctionDetail;
            $auction_items = $auction_company->getAuctionRates;
          

            return view('company.e-auction.edit', compact('auction_items', 'auction_company', 'e_auction'));
            
        } catch (\Throwable $th) {  
            return redirect()->back()->with('error', $th->getMessage());
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
      
        try {
            DB::beginTransaction();   
            $CompanyAuctionData =$request->CompanyAuction; 
             
            foreach ($CompanyAuctionData as  $value) {  
                $company_auction_rate_id = isset($value['auction_detail_id'])?decrypt($value['auction_detail_id']):""; //this is acutally company auction rate table id
                $data['rate'] = isset($value['rate'])?$value['rate']:"";
                $CompanyAuctionRate = CompanyAuctionRate::find($company_auction_rate_id);
                $CompanyAuctionRate->update($data);
            }

            DB::commit(); 
            return redirect('/')->with('success', 'You have succesfully update form.');
        } catch (\Throwable $th) { 
            DB::rollback(); 
            return redirect()->back()->with('error', $th->getMessage());
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    public function print($auction_company_id, $print_type=null)
    { 
        try {
            $id = decrypt($auction_company_id);
             
            $auction_company = AuctionCompany::findOrFail($id);
            $e_auction = $auction_company->getAuctionDetail;
            $company_auction_rates = $auction_company->getAuctionRates;
            $company =  $auction_company->company_detail;
            $todayDate = Carbon::now()->format('Y-m-d');
            // dd($todayDate);
            $todayTime = Carbon::now()->format('H:i:m');


            return view('print.e-auction', compact('company_auction_rates', 'todayDate','todayTime','auction_company', 'e_auction', 'company', 'print_type'));
            
        } catch (\Throwable $th) { 
            dd($th->getMessage());
            return redirect()->back()->with('error', $th->getMessage());
        }
    }  
        public function Remarks(Request $request)
      {
        $attri =$this->validate($request, [
            'remarks'=>'required'
        ]);
        try {
            DB::beginTransaction();
            $id = $request->id;
            $data['remarks']= $request->remarks;

            $record = AuctionDetail::find($id);
        
            $record->update($attri);
            DB::commit();
            return response()->json(['status' => true, 'success' =>true, 'msg' => 'record has been updated']);
        }catch (\Exception $e){
            DB::rollback();
            return response()->json(['status' => false, 'success' =>false, 'msg' => $e->getMessage()]);
        }
    

       

     }
    
    
}
